Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/variable.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/variable.f90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/variable.f90	(revision 5075)
@@ -738,92 +1041,68 @@
       CALL var__get_extra(var__init)
 
-      ! delete some attribute
-      il_attid=att_get_id(var__init%t_att(:),'interpolation')
-      IF( il_attid /= 0 )THEN
-         tl_att=var__init%t_att(il_attid)
-         CALL var_del_att(var__init, tl_att)
-      ENDIF
-      il_attid=att_get_id(var__init%t_att(:),'extrapolation')
-      IF( il_attid /= 0 )THEN
-         tl_att=var__init%t_att(il_attid)
-         CALL var_del_att(var__init, tl_att)
-      ENDIF
-      il_attid=att_get_id(var__init%t_att(:),'filter')
-      IF( il_attid /= 0 )THEN
-         tl_att=var__init%t_att(il_attid)
-         CALL var_del_att(var__init, tl_att)
-      ENDIF
-      il_attid=att_get_id(var__init%t_att(:),'src_file')
-      IF( il_attid /= 0 )THEN
-         tl_att=var__init%t_att(il_attid)
-         CALL var_del_att(var__init, tl_att)
-      ENDIF
-      ! those attribute are deleted cause seems not to be informed correctly
-      il_attid=att_get_id(var__init%t_att(:),'valid_min')
-      IF( il_attid /= 0 )THEN
-         tl_att=var__init%t_att(il_attid)
-         CALL var_del_att(var__init, tl_att)
-      ENDIF
-      il_attid=att_get_id(var__init%t_att(:),'valid_max')
-      IF( il_attid /= 0 )THEN
-         tl_att=var__init%t_att(il_attid)
-         CALL var_del_att(var__init, tl_att)
-      ENDIF
-      il_attid=att_get_id(var__init%t_att(:),'missing_value')
-      IF( il_attid /= 0 )THEN
-         tl_att=var__init%t_att(il_attid)
-         CALL var_del_att(var__init, tl_att)
-      ENDIF
+      ! delete some attribute cause linked to file where variable come from
+      CALL var_del_att(var__init, 'refinment_factor')
+      CALL var_del_att(var__init, 'interpolation')
+      CALL var_del_att(var__init, 'extrapolation')
+      CALL var_del_att(var__init, 'filter')
+      CALL var_del_att(var__init, 'src_file')
+      CALL var_del_att(var__init, 'valid_min')
+      CALL var_del_att(var__init, 'valid_max')
+      CALL var_del_att(var__init, 'missing_value')
+
+      ! clean
+      CALL att_clean(tl_att)
 
    END FUNCTION var__init
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initalise a variable structure.
-   !> - real(8) 1D table of value could be added. 
-   !> - dimension structure could be added.
-   !> - attribute structure could be added
-   !
+   !-------------------------------------------------------------------
+   !> @brief This function initialize a variable structure,
+   !> with a real(8) 1D array of value.
    !> @details 
+   !> Optionally could be added:<br/>
+   !> - dimension structure.
+   !> - attribute structure.
+   !
    !> Dimension structure is needed to put value in variable structure. 
-   !> If none is given, we assume table is ordered as ('z') and we 
-   !> use table size as lentgh dimension. 
+   !> If none is given, we assume array is ordered as ('z') and we 
+   !> use array size as lentgh dimension. 
    !>
    !> indices in the variable where value will be written could be specify if
-   !> start and count table are given. Dimension structure is needed in that 
+   !> start and count array are given. Dimension structure is needed in that 
    !> case.    
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : variable name
-   !> @param[in] dd_value : 1D table of real(8) value
-   !> @param[in] id_start : index in the variable from which the data values 
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_name         variable name
+   !> @param[in] dd_value        1D array of real(8) value
+   !> @param[in] id_start        index in the variable from which the data values 
    !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !> @param[in] id_type : variable type 
-   !> @param[in] td_dim   : dimension structure
-   !> @param[in] td_att  : table of attribute structure
-   !> @param[in] dd_fill : fill value
-   !> @param[in] cd_units : units
-   !> @param[in] cd_stdname : variable standard name
-   !> @param[in] cd_longname : variable long name
-   !> @param[in] cd_point : point on Arakawa-C grid (T,U,V,F)
-   !> @param[in] id_id : variable id
-   !> @param[in] id_ew : east west wrap
-   !> @param[in] dd_scf  : scale factor
-   !> @param[in] dd_ofs  : add offset
-   !> @param[in] id_rec : record id (for rstdimg file)
-   !> @param[in] dd_min : minimum value
-   !> @param[in] dd_max : maximum value
-   !> @param[in] ld_contiguous : use contiguous storage or not 
-   !> @param[in] ld_shuffle :  shuffle filter is turned on or not
-   !> @param[in] ld_fletcher32 : fletcher32 filter is turned on or not
-   !> @param[in] id_deflvl : deflate level from 0 to 9, 0 indicates no deflation is in use
-   !> @param[in] id_chunksz : chunk size
-   !-------------------------------------------------------------------
-   !> @code
+   !> @param[in] id_count        number of indices selected along each dimension
+   !> @param[in] id_type         variable type 
+   !> @param[in] td_dim          dimension structure
+   !> @param[in] td_att          array of attribute structure
+   !> @param[in] dd_fill         fill value
+   !> @param[in] cd_units        units
+   !> @param[in] cd_axis         axis expected to be used
+   !> @param[in] cd_stdname      variable standard name
+   !> @param[in] cd_longname     variable long name
+   !> @param[in] cd_point        point on Arakawa-C grid (T,U,V,F)
+   !> @param[in] id_id           variable id
+   !> @param[in] id_ew           east west wrap
+   !> @param[in] dd_scf          scale factor
+   !> @param[in] dd_ofs          add offset
+   !> @param[in] id_rec          record id (for rstdimg file)
+   !> @param[in] dd_min          minimum value
+   !> @param[in] dd_max          maximum value
+   !> @param[in] ld_contiguous   use contiguous storage or not 
+   !> @param[in] ld_shuffle      shuffle filter is turned on or not
+   !> @param[in] ld_fletcher32   fletcher32 filter is turned on or not
+   !> @param[in] id_deflvl       deflate level from 0 to 9, 0 indicates no deflation is in use
+   !> @param[in] id_chunksz      chunk size
+   !> @return variable structure
+   !-------------------------------------------------------------------
    TYPE(TVAR) FUNCTION var__init_1D_dp( cd_name, dd_value,        &
    &                                    id_start, id_count, id_type, td_dim, &
-   &                                    td_att, dd_fill, cd_units,&
+   &                                    td_att, dd_fill, cd_units, cd_axis, &
    &                                    cd_stdname, cd_longname,  &
    &                                    cd_point, id_id, id_ew,   &
@@ -843,4 +1122,5 @@
       REAL(dp)        ,                       INTENT(IN), OPTIONAL :: dd_fill
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_units
+      CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_axis 
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_stdname
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_longname
@@ -874,5 +1154,5 @@
       CALL var_clean(var__init_1D_dp)
 
-      ! ugly call to avoid warning
+      ! dummy call to avoid warning
       il_type=NF90_DOUBLE
       IF( PRESENT(id_type) ) il_type=id_type
@@ -880,5 +1160,5 @@
       tl_dim(1)=dim_init( 'Z', id_len=SIZE(dd_value(:)) )
       IF( PRESENT(td_dim) )THEN
-         tl_dim(1)=td_dim
+         tl_dim(1)=dim_copy(td_dim)
       ENDIF
 
@@ -895,5 +1175,5 @@
       ! reorder dimension
       CALL dim_reorder(tl_dim(:))
-      ! reorder table
+      ! reorder array
       il_start(:)=dim_reorder_2xyzt(tl_dim(:),il_start(:))
       il_count(:)=dim_reorder_2xyzt(tl_dim(:),il_count(:))
@@ -902,4 +1182,5 @@
       &                          td_dim=tl_dim(:), td_att=td_att,    &
       &                          dd_fill=dd_fill, cd_units=cd_units, &
+      &                          cd_axis=cd_axis,                    &
       &                          cd_stdname=cd_stdname,              &
       &                          cd_longname=cd_longname,            &
@@ -934,58 +1215,63 @@
 
       CALL var_add_value( var__init_1D_dp, dl_value(:,:,:,:), &
-      &                   il_start(:), il_count(:) )
-
+      &                   il_type, il_start(:), il_count(:) )
+
+      ! clean
       DEALLOCATE( dl_value )
+      CALL dim_clean(tl_dim)
 
    END FUNCTION var__init_1D_dp
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initalise a variable structure.
-   !> - real(8) 2D table of value could be added. 
-   !> - dimension structure could be added.
-   !> - attribute structure could be added
+   !-------------------------------------------------------------------
+   !> @brief This function initialize a variable structure,
+   !> with a real(8) 2D array of value. 
+   !> optionally could be added:<br/>
+   !> - dimension structure.
+   !> - attribute structure.
    !
    !> @details 
-   !> table of 2 dimension structure is needed to put value in variable structure. 
-   !> If none is given, we assume table is ordered as ('x','y') and we 
-   !> use table size as lentgh dimension. 
+   !> array of 2 dimension structure is needed to put value in variable structure. 
+   !> If none is given, we assume array is ordered as ('x','y') and we 
+   !> use array size as lentgh dimension. 
    !>
    !> indices in the variable where value will be written could be specify if
-   !> start and count table are given. Dimension structure is needed in that 
+   !> start and count array are given. Dimension structure is needed in that 
    !> case.    
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : variable name
-   !> @param[in] dd_value : 1D table of real(8) value
-   !> @param[in] id_start : index in the variable from which the data values 
-   !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !> @param[in] id_type : variable type 
-   !> @param[in] td_dim   : dimension structure
-   !> @param[in] td_att  : table of attribute structure
-   !> @param[in] dd_fill : fill value
-   !> @param[in] cd_units : units
-   !> @param[in] cd_stdname : variable standard name
-   !> @param[in] cd_longname : variable long name
-   !> @param[in] cd_point : point on Arakawa-C grid (T,U,V,F)
-   !> @param[in] id_id : variable id
-   !> @param[in] id_ew : east west wrap
-   !> @param[in] dd_scf  : scale factor
-   !> @param[in] dd_ofs  : add offset
-   !> @param[in] id_rec : record id (for rstdimg file)
-   !> @param[in] dd_min : minimum value
-   !> @param[in] dd_max : maximum value
-   !> @param[in] ld_contiguous : use contiguous storage or not 
-   !> @param[in] ld_shuffle :  shuffle filter is turned on or not
-   !> @param[in] ld_fletcher32 : fletcher32 filter is turned on or not
-   !> @param[in] id_deflvl : deflate level from 0 to 9, 0 indicates no deflation is in use
-   !> @param[in] id_chunksz : chunk size
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_name         variable name
+   !> @param[in] dd_value        1D array of real(8) value
+   !> @param[in] id_start        index in the variable from which the 
+   !> data values will be read
+   !> @param[in] id_count        number of indices selected along 
+   !> each dimension
+   !> @param[in] id_type         variable type 
+   !> @param[in] td_dim          dimension structure
+   !> @param[in] td_att          array of attribute structure
+   !> @param[in] dd_fill         fill value
+   !> @param[in] cd_units        units
+   !> @param[in] cd_axis         axis expected to be used
+   !> @param[in] cd_stdname      variable standard name
+   !> @param[in] cd_longname     variable long name
+   !> @param[in] cd_point        point on Arakawa-C grid (T,U,V,F)
+   !> @param[in] id_id           variable id
+   !> @param[in] id_ew           east west wrap
+   !> @param[in] dd_scf          scale factor
+   !> @param[in] dd_ofs          add offset
+   !> @param[in] id_rec          record id (for rstdimg file)
+   !> @param[in] dd_min          minimum value
+   !> @param[in] dd_max          maximum value
+   !> @param[in] ld_contiguous   use contiguous storage or not 
+   !> @param[in] ld_shuffle      shuffle filter is turned on or not
+   !> @param[in] ld_fletcher32   fletcher32 filter is turned on or not
+   !> @param[in] id_deflvl       deflate level from 0 to 9, 0 indicates 
+   !> no deflation is in use
+   !> @param[in] id_chunksz      chunk size
+   !> @return variable structure
+   !-------------------------------------------------------------------
    TYPE(TVAR) FUNCTION var__init_2D_dp( cd_name, dd_value,        &
    &                                    id_start, id_count, id_type, td_dim, &
-   &                                    td_att, dd_fill, cd_units,&
+   &                                    td_att, dd_fill, cd_units, cd_axis,&
    &                                    cd_stdname, cd_longname,  &
    &                                    cd_point, id_id, id_ew,   &
@@ -1005,4 +1291,5 @@
       REAL(dp)        ,                       INTENT(IN), OPTIONAL :: dd_fill
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_units
+      CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_axis 
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_stdname
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_longname
@@ -1036,5 +1323,5 @@
       CALL var_clean(var__init_2D_dp)
 
-      ! ugly call to avoid warning
+      ! dummy call to avoid warning
       il_type=NF90_DOUBLE
       IF( PRESENT(id_type) ) il_type=id_type
@@ -1047,6 +1334,6 @@
             &                 " not conform")
          ELSE
-            tl_dim(1)=td_dim(1)
-            tl_dim(2)=td_dim(2)
+            tl_dim(1)=dim_copy(td_dim(1))
+            tl_dim(2)=dim_copy(td_dim(2))
          ENDIF
       ENDIF
@@ -1055,5 +1342,5 @@
       IF( PRESENT(id_start) )THEN
          IF( SIZE(id_start(:)) /= 2 )THEN
-            CALL logger_error("VAR INIT: dimension of start table "//&
+            CALL logger_error("VAR INIT: dimension of start array "//&
             &                 " not conform")
          ELSE
@@ -1066,5 +1353,5 @@
       IF( PRESENT(id_count) )THEN
          IF( SIZE(id_count(:)) /= 2 )THEN
-            CALL logger_error("VAR INIT: dimension of count table "//&
+            CALL logger_error("VAR INIT: dimension of count array "//&
             &                 " not conform")
          ELSE
@@ -1076,5 +1363,5 @@
       ! reorder dimension
       CALL dim_reorder(tl_dim(:))
-      ! reorder table
+      ! reorder array
       il_start(:)=dim_reorder_2xyzt(tl_dim(:),il_start(:))
       il_count(:)=dim_reorder_2xyzt(tl_dim(:),il_count(:))
@@ -1083,4 +1370,5 @@
       &                          td_dim=tl_dim(:), td_att=td_att,    &
       &                          dd_fill=dd_fill, cd_units=cd_units, &
+      &                          cd_axis=cd_axis,                    &
       &                          cd_stdname=cd_stdname,              &
       &                          cd_longname=cd_longname,            &
@@ -1119,58 +1407,63 @@
 
       CALL var_add_value( var__init_2D_dp, dl_value(:,:,:,:), &
-      &                   il_start(:), il_count(:) )
-
+      &                   il_type, il_start(:), il_count(:) )
+
+      ! clean
       DEALLOCATE( dl_value )
+      CALL dim_clean(tl_dim)
 
    END FUNCTION var__init_2D_dp
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initalise a variable structure.
-   !> - real(8) 3D table of value could be added. 
-   !> - dimension structure could be added.
-   !> - attribute structure could be added
-   !
+   !-------------------------------------------------------------------
+   !> @brief This function initialize a variable structure,
+   !> with a real(8) 3D array of value.
    !> @details 
-   !> table of 3 dimension structure is needed to put value in variable structure. 
-   !> If none is given, we assume table is ordered as ('x','y','z') and we 
-   !> use table size as lentgh dimension. 
+   !> optionally could be added:<br/>
+   !> - dimension structure.
+   !> - attribute structure.
+   !>
+   !> array of 3 dimension structure is needed to put value in variable structure. 
+   !> If none is given, we assume array is ordered as ('x','y','z') and we 
+   !> use array size as lentgh dimension. 
    !>
    !> indices in the variable where value will be written could be specify if
-   !> start and count table are given. Dimension structure is needed in that 
+   !> start and count array are given. Dimension structure is needed in that 
    !> case.    
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : variable name
-   !> @param[in] dd_value : 1D table of real(8) value
-   !> @param[in] id_start : index in the variable from which the data values 
-   !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !> @param[in] id_type : variable type 
-   !> @param[in] td_dim   : dimension structure
-   !> @param[in] td_att  : table of attribute structure
-   !> @param[in] dd_fill : fill value
-   !> @param[in] cd_units : units
-   !> @param[in] cd_stdname : variable standard name
-   !> @param[in] cd_longname : variable long name
-   !> @param[in] cd_point : point on Arakawa-C grid (T,U,V,F)
-   !> @param[in] id_id : variable id
-   !> @param[in] id_ew : east west wrap
-   !> @param[in] dd_scf  : scale factor
-   !> @param[in] dd_ofs  : add offset
-   !> @param[in] id_rec : record id (for rstdimg file)
-   !> @param[in] dd_min : minimum value
-   !> @param[in] dd_max : maximum value
-   !> @param[in] ld_contiguous : use contiguous storage or not 
-   !> @param[in] ld_shuffle :  shuffle filter is turned on or not
-   !> @param[in] ld_fletcher32 : fletcher32 filter is turned on or not
-   !> @param[in] id_deflvl : deflate level from 0 to 9, 0 indicates no deflation is in use
-   !> @param[in] id_chunksz : chunk size
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_name         variable name
+   !> @param[in] dd_value        1D array of real(8) value
+   !> @param[in] id_start        index in the variable from which the 
+   !> data values will be read
+   !> @param[in] id_count        number of indices selected along 
+   !> each dimension
+   !> @param[in] id_type         variable type 
+   !> @param[in] td_dim          dimension structure
+   !> @param[in] td_att          array of attribute structure
+   !> @param[in] dd_fill         fill value
+   !> @param[in] cd_units        units
+   !> @param[in] cd_axis         axis expected to be used
+   !> @param[in] cd_stdname      variable standard name
+   !> @param[in] cd_longname     variable long name
+   !> @param[in] cd_point        point on Arakawa-C grid (T,U,V,F)
+   !> @param[in] id_id           variable id
+   !> @param[in] id_ew           east west wrap
+   !> @param[in] dd_scf          scale factor
+   !> @param[in] dd_ofs          add offset
+   !> @param[in] id_rec          record id (for rstdimg file)
+   !> @param[in] dd_min          minimum value
+   !> @param[in] dd_max          maximum value
+   !> @param[in] ld_contiguous   use contiguous storage or not 
+   !> @param[in] ld_shuffle       shuffle filter is turned on or not
+   !> @param[in] ld_fletcher32   fletcher32 filter is turned on or not
+   !> @param[in] id_deflvl       deflate level from 0 to 9, 0 indicates no 
+   !> deflation is in use
+   !> @param[in] id_chunksz      chunk size
+   !> @return variable structure
+   !-------------------------------------------------------------------
    TYPE(TVAR) FUNCTION var__init_3D_dp( cd_name, dd_value,        &
    &                                    id_start, id_count, id_type, td_dim, &
-   &                                    td_att, dd_fill, cd_units,&
+   &                                    td_att, dd_fill, cd_units, cd_axis,&
    &                                    cd_stdname, cd_longname,  &
    &                                    cd_point, id_id, id_ew,   &
@@ -1190,4 +1483,5 @@
       REAL(dp)        ,                       INTENT(IN), OPTIONAL :: dd_fill
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_units
+      CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_axis 
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_stdname
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_longname
@@ -1221,5 +1515,5 @@
       CALL var_clean(var__init_3D_dp)
 
-      ! ugly call to avoid warning
+      ! dummy call to avoid warning
       il_type=NF90_DOUBLE
       IF( PRESENT(id_type) ) il_type=id_type
@@ -1233,7 +1527,7 @@
             &                 " not conform")
          ELSE
-            tl_dim(1)=td_dim(1)
-            tl_dim(2)=td_dim(2)
-            tl_dim(3)=td_dim(3)
+            tl_dim(1)=dim_copy(td_dim(1))
+            tl_dim(2)=dim_copy(td_dim(2))
+            tl_dim(3)=dim_copy(td_dim(3))
          ENDIF
       ENDIF
@@ -1242,5 +1536,5 @@
       IF( PRESENT(id_start) )THEN
          IF( SIZE(id_start(:)) /= 3 )THEN
-            CALL logger_error("VAR INIT: dimension of start table "//&
+            CALL logger_error("VAR INIT: dimension of start array "//&
             &                 " not conform")
          ELSE
@@ -1254,5 +1548,5 @@
       IF( PRESENT(id_count) )THEN
          IF( SIZE(id_count(:)) /= 3 )THEN
-            CALL logger_error("VAR INIT: dimension of count table "//&
+            CALL logger_error("VAR INIT: dimension of count array "//&
             &                 " not conform")
          ELSE
@@ -1265,5 +1559,5 @@
       ! reorder dimension
       CALL dim_reorder(tl_dim(:))
-      ! reorder table
+      ! reorder array
       il_start(:)=dim_reorder_2xyzt(tl_dim(:),il_start(:))
       il_count(:)=dim_reorder_2xyzt(tl_dim(:),il_count(:))
@@ -1272,4 +1566,5 @@
       &                          td_dim=tl_dim(:), td_att=td_att,    &
       &                          dd_fill=dd_fill, cd_units=cd_units, &
+      &                          cd_axis=cd_axis,                    &
       &                          cd_stdname=cd_stdname,              &
       &                          cd_longname=cd_longname,            &
@@ -1304,58 +1599,63 @@
 
       CALL var_add_value( var__init_3D_dp, dl_value(:,:,:,:), &
-      &                   il_start(:), il_count(:) )
-
+      &                   il_type, il_start(:), il_count(:) )
+
+      ! clean
       DEALLOCATE( dl_value )
+      CALL dim_clean(tl_dim)
 
    END FUNCTION var__init_3D_dp
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initalise a variable structure.
-   !> - real(8) 4D table of value could be added. 
-   !> - dimension structure could be added.
-   !> - attribute structure could be added
-   !
+   !-------------------------------------------------------------------
+   !> @brief This function initialize a variable structure,
+   !> with a real(8) 4D array of value.
    !> @details 
+   !> optionally could be added:<br/>
+   !> - dimension structure.
+   !> - attribute structure.
+   !>
    !> Dimension structure is needed to put value in variable structure. 
-   !> If none is given, we assume table is ordered as ('x','y','z','t') and we 
-   !> use table size as lentgh dimension. 
+   !> If none is given, we assume array is ordered as ('x','y','z','t') and we 
+   !> use array size as lentgh dimension. 
    !>
    !> indices in the variable where value will be written could be specify if
-   !> start and count table are given. Dimension structure is needed in that 
+   !> start and count array are given. Dimension structure is needed in that 
    !> case.    
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : variable name
-   !> @param[in] dd_value : 4D table of real(8) value
-   !> @param[in] id_start : index in the variable from which the data values 
-   !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !> @param[in] id_type : variable type 
-   !> @param[in] td_dim   : table of dimension structure
-   !> @param[in] td_att  : table of attribute structure
-   !> @param[in] dd_fill : fill value
-   !> @param[in] cd_units : units
-   !> @param[in] cd_stdname : variable standard name
-   !> @param[in] cd_longname : variable long name
-   !> @param[in] cd_point : point on Arakawa-C grid (T,U,V,F)
-   !> @param[in] id_id : variable id
-   !> @param[in] id_ew : east west wrap
-   !> @param[in] dd_scf  : scale factor
-   !> @param[in] dd_ofs  : add offset
-   !> @param[in] id_rec : record id (for rstdimg file)
-   !> @param[in] dd_min : minimum value
-   !> @param[in] dd_max : maximum value
-   !> @param[in] ld_contiguous : use contiguous storage or not 
-   !> @param[in] ld_shuffle :  shuffle filter is turned on or not
-   !> @param[in] ld_fletcher32 : fletcher32 filter is turned on or not
-   !> @param[in] id_deflvl : deflate level from 0 to 9, 0 indicates no deflation is in use
-   !> @param[in] id_chunksz : chunk size
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_name         variable name
+   !> @param[in] dd_value        4D array of real(8) value
+   !> @param[in] id_start        index in the variable from which the 
+   !> data values will be read
+   !> @param[in] id_count        number of indices selected along 
+   !> each dimension
+   !> @param[in] id_type         variable type 
+   !> @param[in] td_dim          array of dimension structure
+   !> @param[in] td_att          array of attribute structure
+   !> @param[in] dd_fill         fill value
+   !> @param[in] cd_units        units
+   !> @param[in] cd_axis         axis expected to be used
+   !> @param[in] cd_stdname      variable standard name
+   !> @param[in] cd_longname     variable long name
+   !> @param[in] cd_point        point on Arakawa-C grid (T,U,V,F)
+   !> @param[in] id_id           variable id
+   !> @param[in] id_ew           east west wrap
+   !> @param[in] dd_scf          scale factor
+   !> @param[in] dd_ofs          add offset
+   !> @param[in] id_rec          record id (for rstdimg file)
+   !> @param[in] dd_min          minimum value
+   !> @param[in] dd_max          maximum value
+   !> @param[in] ld_contiguous   use contiguous storage or not 
+   !> @param[in] ld_shuffle       shuffle filter is turned on or not
+   !> @param[in] ld_fletcher32   fletcher32 filter is turned on or not
+   !> @param[in] id_deflvl       deflate level from 0 to 9, 0 indicates no 
+   !> deflation is in use
+   !> @param[in] id_chunksz      chunk size
+   !> @return variable structure
+   !-------------------------------------------------------------------
    TYPE(TVAR) FUNCTION var__init_dp( cd_name, dd_value,        &
    &                                 id_start, id_count, id_type, td_dim, &
-   &                                 td_att, dd_fill, cd_units,&
+   &                                 td_att, dd_fill, cd_units, cd_axis,&
    &                                 cd_stdname, cd_longname,  &
    &                                 cd_point, id_id, id_ew,   &
@@ -1375,4 +1675,5 @@
       REAL(dp)        ,                       INTENT(IN), OPTIONAL :: dd_fill
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_units
+      CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_axis 
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_stdname
       CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_longname
@@ -1404,5 +1705,5 @@
       CALL var_clean(var__init_dp)
 
-      ! ugly call to avoid warning
+      ! dummy call to avoid warning
       il_type=NF90_DOUBLE
       IF( PRESENT(id_type) ) il_type=id_type
@@ -1411,4 +1712,5 @@
       &                       td_dim=td_dim, td_att=td_att,       &
       &                       dd_fill=dd_fill, cd_units=cd_units, &
+      &                       cd_axis=cd_axis,                    &
       &                       cd_stdname=cd_stdname,              &
       &                       cd_longname=cd_longname,            &
@@ -1422,5 +1724,5 @@
       &                       id_deflvl=id_deflvl,                &
       &                       id_chunksz=id_chunksz(:))
-   
+ 
       ! add value
       IF( .NOT. PRESENT(td_dim) )THEN
